/*
 * vim:ts=4:sw=4:expandtab
 *
 * © 2010 Michael Stapelberg <michael@stapelberg.de>
 * RELEASED INTO PUBLIC DOMAIN, WITHOUT ANY WARRANTY
 *
 */
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <err.h>

int main() {
    int ret;

    struct addrinfo *res;
    struct addrinfo hints;
    memset(&hints, 0, sizeof(struct addrinfo));
    hints.ai_family = PF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    if ((ret = getaddrinfo("www.google.de", "http", &hints, &res)) != 0)
        errx(EXIT_FAILURE, "getaddrinfo(i3.zekjur.net) = %s\n", gai_strerror(ret));

    struct addrinfo *walk;
    char buf[INET6_ADDRSTRLEN+1];
    for (walk = res; walk != NULL; walk = walk->ai_next) {
        memset(buf, 0, INET6_ADDRSTRLEN+1);
        if ((ret = getnameinfo((struct sockaddr*)walk->ai_addr, walk->ai_addrlen,
                               buf, sizeof(buf), NULL, 0, NI_NUMERICHOST)) != 0)
            errx(EXIT_FAILURE, "getnameinfo(): %s\n", gai_strerror(ret));
        printf("www.google.de resolved to %s\n", buf);
    }
}
